Loading...
Searching...
No Matches
pcl::FarthestPointSampling< PointT > Class Template Reference
Module filters

FarthestPointSampling applies farthest point sampling using euclidean distance, starting with a random point, utilizing a naive method. More...

`#include <pcl/filters/farthest_point_sampling.h>`

Inheritance diagram for pcl::FarthestPointSampling< PointT >:

## Public Member Functions

| FarthestPointSampling (bool extract_removed_indices=false)
| Empty constructor.
void | setSample (std::size_t sample_size)
| Set number of points to be sampled.
std::size_t | getSample () const
| Get the value of the internal sample_size parameter.
void | setSeed (unsigned int seed)
| Set seed of random function.
unsigned int | getSeed () const
| Get the value of the internal seed_ parameter.
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor.
void | filter (Indices &indices)
| Calls the filtering method and returns the filtered point cloud indices.
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions.
bool | getNegative () const
| Get whether the regular conditions for points filtering should apply, or the inverted conditions.
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
bool | getKeepOrganized () const
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them.
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor.
IndicesConstPtr const | getRemovedIndices () const
| Get the point indices being removed.
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed.
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output.
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

void | applyFilter (pcl::Indices &indices) override
| Sample of point indices.
Protected Member Functions inherited from pcl::FilterIndices< PointT >
void | applyFilter (PointCloud &output) override
| Abstract filter method for point cloud.
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

std::size_t | sample_size_
| Number of points that will be returned.
unsigned int | seed_
| Random number seed.
Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_ {false}
| False = normal filter behavior (default), true = inverted behavior.
bool | keep_organized_ {false}
| False = remove points (default), true = redefine points, keep structure.
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN).
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed.
std::string | filter_name_
| The filter name.
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points.
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Additional Inherited Members

Public Types inherited from pcl::FilterIndices< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | Ptr = shared_ptr< FilterIndices< PointT > >
using | ConstPtr = shared_ptr< const FilterIndices< PointT > >
Public Types inherited from pcl::Filter< PointT >
using | Ptr = shared_ptr< Filter< PointT > >
using | ConstPtr = shared_ptr< const Filter< PointT > >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Detailed Description

template<typename PointT>
class pcl::FarthestPointSampling< PointT >

FarthestPointSampling applies farthest point sampling using euclidean distance, starting with a random point, utilizing a naive method.

Author
  Haritha Jayasinghe

Todo:
  add support to export/import distance metric

Definition at line 26 of file farthest_point_sampling.h.

## Constructor & Destructor Documentation

## FarthestPointSampling()

template<typename PointT >

pcl::FarthestPointSampling< PointT >::FarthestPointSampling | ( | bool | extract_removed_indices = `false` | ) |

inline

Empty constructor.

Definition at line 40 of file farthest_point_sampling.h.

References pcl::Filter< PointT >::filter_name_.

## Member Function Documentation

## applyFilter()

template<typename PointT >

void pcl::FarthestPointSampling< PointT >::applyFilter | ( | pcl::Indices & | indices | ) |

override protected virtual

Sample of point indices.

Parameters

  indices | indices of the filtered point cloud

Implements pcl::FilterIndices< PointT >.

Definition at line 21 of file farthest_point_sampling.hpp.

## getSample()

template<typename PointT >

std::size_t pcl::FarthestPointSampling< PointT >::getSample | ( |  | ) | const

inline

Get the value of the internal sample_size parameter.

Definition at line 60 of file farthest_point_sampling.h.

References pcl::FarthestPointSampling< PointT >::sample_size_.

## getSeed()

template<typename PointT >

unsigned int pcl::FarthestPointSampling< PointT >::getSeed | ( |  | ) | const

inline

Get the value of the internal seed_ parameter.

Definition at line 77 of file farthest_point_sampling.h.

References pcl::FarthestPointSampling< PointT >::seed_.

## setSample()

template<typename PointT >

void pcl::FarthestPointSampling< PointT >::setSample | ( | std::size_t | sample_size | ) |

inline

Set number of points to be sampled.

Parameters

  sample_size | the number of points to sample

Definition at line 52 of file farthest_point_sampling.h.

References pcl::FarthestPointSampling< PointT >::sample_size_.

## setSeed()

template<typename PointT >

void pcl::FarthestPointSampling< PointT >::setSeed | ( | unsigned int | seed | ) |

inline

Set seed of random function.

Parameters

  seed | for the random number generator, to choose the first sample point

Definition at line 69 of file farthest_point_sampling.h.

References pcl::FarthestPointSampling< PointT >::seed_.

## Member Data Documentation

## sample_size_

template<typename PointT >

std::size_t pcl::FarthestPointSampling< PointT >::sample_size_

protected

Number of points that will be returned.

Definition at line 85 of file farthest_point_sampling.h.

Referenced by pcl::FarthestPointSampling< PointT >::getSample(), and pcl::FarthestPointSampling< PointT >::setSample().

## seed_

template<typename PointT >

unsigned int pcl::FarthestPointSampling< PointT >::seed_

protected

Random number seed.

Definition at line 87 of file farthest_point_sampling.h.

Referenced by pcl::FarthestPointSampling< PointT >::getSeed(), and pcl::FarthestPointSampling< PointT >::setSeed().

The documentation for this class was generated from the following files:

- pcl/filters/farthest_point_sampling.h
- pcl/filters/impl/farthest_point_sampling.hpp